<?php
function recuperer_comments()
{
	global $bdd_posh, $tb_comments;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT * FROM $tb_comments");
		$reponse -> execute(array());
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_comments_recents($nbr_der_activites)
{
	global $bdd_posh, $tb_comments, $ch_cts_pubdate;
	global $ch_cts_message, $ch_cts_pubdate;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_cts_message, DATE_FORMAT($ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater FROM $tb_comments ORDER BY $ch_cts_pubdate DESC LIMIT 0,?");
		$reponse -> bindValue(1, $nbr_der_activites, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function desactiver_comment($id)
{
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_status, $ch_cts_article_id;
	global $ch_art_id, $ch_art_commentsnb;
	
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_id = ?");
		$reponse -> execute(array("D",$id));	
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_commentsnb = $ch_art_commentsnb - 1 ".
									  "WHERE $ch_art_id = (SELECT $ch_cts_article_id FROM $tb_comments WHERE $ch_cts_id = ?)");
		$reponse -> execute(array($id));	
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;
	}
	return true;
}
function reactiver_comment($id)
{
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_status, $ch_cts_article_id;
	global $ch_art_id, $ch_art_commentsnb;
	
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_id = ?");
		$reponse -> execute(array("O",$id));	
		$reponse -> closeCursor();	

		$reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_commentsnb = $ch_art_commentsnb + 1 ".
									  "WHERE $ch_art_id = (SELECT $ch_cts_article_id FROM $tb_comments WHERE $ch_cts_id = ?)");
		$reponse -> execute(array($id));	
		$reponse -> closeCursor();
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
		return false;
	}
	return true;
}
function supprimer_comment($id)
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("DELETE FROM $tb_comments WHERE $ch_cts_status = ? AND $ch_cts_id = ?");
		$reponse -> execute(array("D",$id));	
		$reponse -> closeCursor();			
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;
	}
	return true;
}
function compter_comments()
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_cts_id) AS cpt_comment FROM $tb_comments");
		$reponse -> execute(array());
		$donnees = $reponse->fetch();
		$cpt_comments = $donnees['cpt_comment'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_comments;
}
function compter_comments_sansmess()
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id, $ch_cts_message, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_cts_id) AS cpt_comment ".
									  "FROM $tb_comments ".
									  "WHERE $ch_cts_message = '' AND $ch_cts_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_comments = $donnees['cpt_comment'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_comments;
}
function compter_comments_delete()
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_cts_id) AS cpt_comment ".
									  "FROM $tb_comments ".
									  "WHERE $ch_cts_status = ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_comments = $donnees['cpt_comment'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_comments;
}
function compter_comments_sans_gestion()
{
	global $bdd_posh, $tb_comments, $tb_users;
	global $ch_cts_id, $ch_cts_status, $ch_cts_user_id;
	global $ch_users_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_cts_id) AS cpt_comment ".
									  "FROM $tb_comments ".
									  "WHERE $ch_cts_user_id NOT IN (SELECT $ch_users_id FROM $tb_users)".
									  "AND $ch_cts_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_comments = $donnees['cpt_comment'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_comments;
}
function compter_comments_intervalle($intervalle)
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id, $ch_cts_pubdate, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_cts_id) AS cpt_comment ".
									  "FROM $tb_comments ".
									  "WHERE $ch_cts_pubdate >= DATE_SUB(CURDATE(),INTERVAL ? DAY) ".
									  "AND $ch_cts_status != ?");
		$reponse -> execute(array($intervalle,"D"));
		$donnees = $reponse->fetch();
		$cpt_comments = $donnees['cpt_comment'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_comments;
}
function recuperer_comments_intervalle($champ,$order,$intervalle,$depart,$delta){
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id AS comment_id, $ch_cts_article_id, $tb_article.$ch_art_id, $ch_art_title, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status ".
									  "FROM $tb_comments, $tb_article ".
									  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
									  "AND $tb_comments.$ch_cts_pubdate >= DATE_SUB(CURDATE(),INTERVAL ? DAY) ".
									  "AND $tb_comments.$ch_cts_status != ? ".
									  "ORDER BY $tb_comments.$champ $order LIMIT ?,?");		
		$reponse -> bindValue(1, $intervalle, PDO::PARAM_INT);
		$reponse -> bindValue(2, "D", PDO::PARAM_STR);
		$reponse -> bindValue(3, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(4, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_comments_total($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id AS comment_id, $ch_cts_article_id, $tb_article.$ch_art_id, $ch_art_title, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status ".
									  "FROM $tb_comments, $tb_article ".
									  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
									  "ORDER BY $tb_comments.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(2, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_comments_vide_mess($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id AS comment_id, $ch_cts_article_id, $tb_article.$ch_art_id, $ch_art_title, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status ".
									  "FROM $tb_comments, $tb_article ".
		 							  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
									  "AND $ch_cts_message = '' AND $tb_comments.$ch_cts_status != ? ".
									  "ORDER BY $tb_comments.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_comments_delete($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_comments, $tb_article;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id AS comment_id, $ch_cts_article_id, $tb_article.$ch_art_id, $ch_art_title, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status ".
									  "FROM $tb_comments, $tb_article ".
									  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
									  "AND $tb_comments.$ch_cts_status = ? ".
									  "ORDER BY $tb_comments.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_comments_sans_gestion($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_comments, $tb_users, $tb_article;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	global $ch_users_id;
	
	$comments = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id AS comment_id, $ch_cts_article_id, $tb_article.$ch_art_id, $ch_art_title, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status ".
									  "FROM $tb_comments, $tb_article ".
								 	  "WHERE $ch_cts_user_id NOT IN (SELECT $ch_users_id FROM $tb_users) ".
									  "AND $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
								 	  "AND $tb_comments.$ch_cts_status != ? ".
								 	  "ORDER BY $tb_comments.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $comments[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $comments;
}
function recuperer_infos_comment($id)
{
	global $bdd_posh, $tb_comments, $tb_article, $tb_users;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, $ch_cts_pubdate, $ch_cts_status;
	global $ch_art_id, $ch_art_title;
	global $ch_users_id, $ch_users_username;
	
	$infos = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status, $ch_art_title, $ch_users_username ".									 
									  "FROM $tb_comments, $tb_article, $tb_users ".
									  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".
									  "AND $tb_comments.$ch_cts_user_id = $tb_users.$ch_users_id ".
									  "AND $tb_comments.$ch_cts_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{	
			 $infos[] = $donnees;
		}
		//Si l'user a été supprimé de la base, la requête au dessus ne fonctionnera pas, on va donc la simplifier
		//Un article n'est pas censé être supprimé, il est désactivé, donc la requête qui suit fonctionnera toujours.
		//Le seule moyen de supprimer un article est de passer par SAP, qui lui supprime aussi les commentaires de l'article, donc impossible d'en arriver là avec un article delete.
		if(empty($infos)){
			$reponse = $bdd_posh->prepare("SELECT $tb_comments.$ch_cts_id, $ch_cts_article_id, $ch_cts_user_id, $ch_cts_message, DATE_FORMAT($tb_comments.$ch_cts_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $tb_comments.$ch_cts_status, $ch_art_title ".									 
										  "FROM $tb_comments,$tb_article ".	
										  "WHERE $tb_comments.$ch_cts_article_id = $tb_article.$ch_art_id ".										  
										  "AND $tb_comments.$ch_cts_id = ?");
			$reponse -> execute(array($id));
			while ($donnees = $reponse->fetch())
			{	
				 $infos[] = $donnees;
			}
		}	
		
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $infos;
}
function recuperer_comment_recherche_message($texte)
{
	global $bdd_posh, $tb_comments;
	global $ch_cts_id, $ch_cts_message;
	
	$comments = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_cts_id, $ch_cts_message FROM $tb_comments WHERE $ch_cts_message LIKE '%' ? '%'");
		$reponse -> execute(array($texte));		
		while($donnees = $reponse->fetch())
		{
			$comments[] = $donnees;
		}
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	} 
	return $comments;
}
