<?php
function recuperer_groups($private)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_status, $ch_grp_private;
	
	$groups = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT * FROM $tb_groups WHERE $ch_grp_status = ? AND $ch_grp_private = ?");
		$reponse -> execute(array("1",$private));
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_recents($nbr_der_activites)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_name, $ch_grp_creation_date, $ch_grp_status, $ch_grp_private, $ch_grp_creation_date;
	
	$groups = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_name, DATE_FORMAT($ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater FROM $tb_groups ORDER BY $ch_grp_creation_date DESC LIMIT 0,?");
		$reponse -> bindValue(1, $nbr_der_activites, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function desactiver_group($id)
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map, $tb_groups_articles_map, $tb_article, $tb_comments;
	global $ch_grp_status, $ch_grp_private, $ch_grp_id;
	global $ch_grp_um_status, $ch_grp_um_group_id;
	global $ch_grp_am_status, $ch_grp_am_group_id, $ch_grp_am_article_id;
	global $ch_art_id, $ch_art_status;
	global $ch_cts_article_id, $ch_cts_status;
	//Désactivation en cascade, groupes, puis articles du groupe, et ensuite les commentaire des articles
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups SET $ch_grp_private = ?, $ch_grp_status = ? WHERE $ch_grp_id = ?");
		$reponse -> execute(array("1","D",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups_users_map SET $ch_grp_um_status = ? WHERE $ch_grp_um_group_id = ?");
		$reponse -> execute(array("S",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_group_id = ?");
		$reponse -> execute(array("D",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_am_article_id FROM $tb_groups_articles_map WHERE $ch_grp_am_group_id = ?");
		$reponse -> execute(array($id));
		
		foreach($reponse as $row){
			$reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_status = ? WHERE $ch_art_id = ?");
			$reponse -> execute(array("D",$row[$ch_grp_am_article_id]));			
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_article_id = ?");
			$reponse -> execute(array("D",$row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_article_id = ?");
			$reponse -> execute(array("D",$row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
		}
		
		$reponse -> closeCursor();
		
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;		
	}
	return true;
}
function reactiver_group($id)
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map, $tb_groups_articles_map, $tb_article, $tb_comments;
	global $ch_grp_status, $ch_grp_private, $ch_grp_id;
	global $ch_grp_um_status, $ch_grp_um_group_id;
	global $ch_grp_am_status, $ch_grp_am_group_id, $ch_grp_am_article_id;
	global $ch_art_id, $ch_art_status, $ch_art_commentsnb;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups SET $ch_grp_private = ?, $ch_grp_status = ? WHERE $ch_grp_id = ?");
		$reponse -> execute(array("1","1",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups_users_map SET $ch_grp_um_status = ? WHERE $ch_grp_um_group_id = ?");
		$reponse -> execute(array("O",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_group_id = ?");
		$reponse -> execute(array("2",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_am_article_id FROM $tb_groups_articles_map WHERE $ch_grp_am_group_id = ?");
		$reponse -> execute(array($id));
		
		foreach($reponse as $row){
			$reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_status = ? WHERE $ch_art_id = ?");
			$reponse -> execute(array("2",$row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_article_id = ?");
			$reponse -> execute(array("2",$row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_article_id = ?");
			$reponse -> execute(array("O",$row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			//On remet le compteur des comentaires à jour
			$reponse = $bdd_posh->prepare("SELECT count($ch_cts_id) FROM $tb_comments WHERE $ch_cts_article_id = ?");
			$reponse -> execute(array($row[$ch_grp_am_article_id]));
			$number_of_rows = $reponse->fetchColumn();
			
			$reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_commentsnb = ? WHERE $ch_art_id = ?");
			$reponse -> execute(array($number_of_rows, $row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
		}
		
		$reponse -> closeCursor();
		
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;		
	}
	return true;
}
function supprimer_group($id)
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map, $tb_groups_articles_map, $tb_article, $tb_comments;
	global $ch_grp_status, $ch_grp_id;
	global $ch_grp_um_status, $ch_grp_um_group_id;
	global $ch_grp_am_status, $ch_grp_am_group_id, $ch_grp_am_article_id;
	global $ch_art_id, $ch_art_status;
	global $ch_cts_article_id, $ch_cts_status;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_am_article_id FROM $tb_groups_articles_map WHERE $ch_grp_am_status = ? AND $ch_grp_am_group_id = ?");
		$reponse -> execute(array("D",$id));
		
		foreach($reponse as $row){
			$reponse = $bdd_posh->prepare("DELETE FROM $tb_article WHERE $ch_art_id = ?");
			$reponse -> execute(array($row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("DELETE FROM $tb_groups_articles_map WHERE $ch_grp_am_article_id = ?");
			$reponse -> execute(array($row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
			
			$reponse = $bdd_posh->prepare("DELETE FROM $tb_comments WHERE $ch_cts_article_id = ?");
			$reponse -> execute(array($row[$ch_grp_am_article_id]));
			$reponse -> closeCursor();
		}
		
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("DELETE FROM $tb_groups WHERE $ch_grp_status = ? AND $ch_grp_id = ?");
		$reponse -> execute(array("D",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("DELETE FROM $tb_groups_users_map WHERE $ch_grp_um_status = ? AND $ch_grp_um_group_id = ?");
		$reponse -> execute(array("S",$id));
		$reponse -> closeCursor();
		
		$reponse = $bdd_posh->prepare("DELETE FROM $tb_groups_articles_map WHERE $ch_grp_am_status = ? AND $ch_grp_am_group_id = ?");
		$reponse -> execute(array("D",$id));
		$reponse -> closeCursor();
		
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;		
	}
	return true;
}
function recuperer_group($id)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_status;
	
	$group = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT * FROM $tb_groups WHERE $ch_grp_status = ?");
		$reponse -> execute(array($id,"1"));		
		while($donnees = $reponse->fetch())
		{					
			$group[] = $donnees;
		}
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	} 
	return $group;
}
function compter_groupe()
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_grp_id) AS cpt_groupe FROM $tb_groups");
		$reponse -> execute(array());
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_sansmembre()
{
	global $bdd_posh, $tb_groups_users_map, $tb_groups;
	global $ch_grp_id, $ch_grp_status;
	global $ch_grp_um_status, $ch_grp_um_group_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) AS cpt_groupe ".
									  "FROM $tb_groups, $tb_groups_users_map ".
									  "WHERE $tb_groups_users_map.$ch_grp_um_group_id = $tb_groups.$ch_grp_id ".	
									  "AND $ch_grp_um_group_id ".
									  "IN(SELECT $ch_grp_um_group_id FROM $tb_groups_users_map GROUP BY $ch_grp_um_group_id HAVING count(*)=1) ".
									  "AND $tb_groups.$ch_grp_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_sansarticle()
{
	global $bdd_posh, $tb_groups, $tb_groups_articles_map;
	global $ch_grp_status, $ch_grp_id;
	global $ch_grp_am_group_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe ".
									  "FROM $tb_groups ".
									  "WHERE $ch_grp_id ".
									  "NOT IN (SELECT DISTINCT $ch_grp_am_group_id FROM $tb_groups_articles_map) ".
									  "AND $ch_grp_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}

function compter_groupe_sansarticle_membre()
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map, $tb_groups_articles_map;
	global $ch_grp_status, $ch_grp_id;
	global $ch_grp_um_group_id;
	global $ch_grp_am_group_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe ".
									  "FROM $tb_groups ".
									  "WHERE $ch_grp_id IN (SELECT $ch_grp_um_group_id FROM $tb_groups_users_map GROUP BY $ch_grp_um_group_id HAVING count(*)=1) ".
									  "AND $ch_grp_id NOT IN (SELECT DISTINCT $ch_grp_am_group_id FROM $tb_groups_articles_map) ".
									  "AND $ch_grp_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_prive()
{
	global $bdd_posh, $tb_groups;	
	global $ch_grp_status, $ch_grp_private;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe FROM $tb_groups WHERE $ch_grp_private = ? AND $ch_grp_status != ?");
		$reponse -> execute(array("1","D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_public()
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_status, $ch_grp_private;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe FROM $tb_groups WHERE $ch_grp_private = ? AND $ch_grp_status != ?");
		$reponse -> execute(array("0","D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_inactif()
{
	global $bdd_posh, $tb_groups, $tb_groups_articles_map, $tb_article;
	global $ch_grp_id, $ch_grp_status;
	global $ch_grp_am_group_id, $ch_grp_am_article_id;
	global $ch_art_id, $ch_art_pubdate;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe ".
									  "FROM( ".
									  		"SELECT * ".
											"FROM( ".
												"SELECT $ch_grp_am_group_id, $ch_grp_am_article_id, $ch_art_pubdate, $tb_groups.$ch_grp_status ".
												"FROM $tb_groups_articles_map, $tb_article, $tb_groups ".
												"WHERE $tb_article.$ch_art_id = $tb_groups_articles_map.$ch_grp_am_article_id ".
											    "AND $tb_groups.$ch_grp_id = $tb_groups_articles_map.$ch_grp_am_group_id ".
												"ORDER BY $ch_grp_am_group_id, $ch_art_pubdate DESC ".
											") TableFull ".
											"GROUP BY $ch_grp_am_group_id ".
										") TableMiFull ".
										"WHERE $ch_art_pubdate <= DATE_SUB(CURDATE(),INTERVAL 365 DAY) ".
										"AND $ch_grp_status != ? ");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_delete()
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_status;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe FROM $tb_groups WHERE $ch_grp_status = ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function compter_groupe_sans_gestion()
{
	global $bdd_posh, $tb_users, $tb_groups;
	global $ch_grp_created_by, $ch_grp_status;
	global $ch_users_id;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT(*) as cpt_groupe FROM $tb_groups WHERE $ch_grp_created_by NOT IN (SELECT $ch_users_id FROM $tb_users) AND $ch_grp_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_groupe = $donnees['cpt_groupe'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_groupe;
}
function recuperer_groups_total($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_creation_date, $ch_grp_private, $ch_grp_allowUnsubscribe, $ch_grp_description, $ch_grp_status;	
		
	$groups = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status ".
								      "FROM $tb_groups ".								     
								 	  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(2, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_vide_article($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups, $tb_groups_articles_map;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status;
	global $ch_grp_am_group_id, $ch_grp_am_article_id;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_private, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $tb_groups.$ch_grp_description, $ch_grp_status ".
							 		  "FROM $tb_groups ".							  		 
							  		  "WHERE $tb_groups.$ch_grp_id NOT IN (SELECT DISTINCT $ch_grp_am_group_id FROM $tb_groups_articles_map) AND $ch_grp_status != ? ".
								      "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_vide_articlemembre($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map, $tb_groups_articles_map;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status;
	global $ch_grp_um_group_id;
	global $ch_grp_am_group_id;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_private, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $tb_groups.$ch_grp_description, $ch_grp_status ".
							 		  "FROM $tb_groups ".
									  "WHERE $tb_groups.$ch_grp_id IN (SELECT $ch_grp_um_group_id FROM $tb_groups_users_map GROUP BY $ch_grp_um_group_id HAVING count(*)=1) ".
							  		  "AND $tb_groups.$ch_grp_id NOT IN (SELECT DISTINCT $ch_grp_am_group_id FROM $tb_groups_articles_map) ".							  		  
							  		  "AND $ch_grp_status != ? ".
								      "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_vide_membre($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups, $tb_groups_users_map;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status;
	global $ch_grp_um_group_id;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $tb_groups.$ch_grp_description, $tb_groups.$ch_grp_status, $tb_groups_users_map.$ch_grp_um_group_id ".
									  "FROM $tb_groups, $tb_groups_users_map ".
									  "WHERE $tb_groups_users_map.$ch_grp_um_group_id = $tb_groups.$ch_grp_id ".									 
									  "AND $ch_grp_um_group_id IN (SELECT $ch_grp_um_group_id FROM $tb_groups_users_map GROUP BY $ch_grp_um_group_id HAVING count(*)=1) ".
									  "AND $tb_groups.$ch_grp_status != ? ".
									  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_prive($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status, $ch_grp_allowUnsubscribe;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status ".
								      "FROM $tb_groups ".								    
									  "WHERE $ch_grp_private = ? AND $ch_grp_status != ? ".
								 	  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");		
		$reponse -> bindValue(1, "1", PDO::PARAM_INT);
		$reponse -> bindValue(2, "D", PDO::PARAM_STR);
		$reponse -> bindValue(3, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(4, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_public($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status, $ch_grp_allowUnsubscribe;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status ".
								      "FROM $tb_groups ".								     
		 							  "WHERE $ch_grp_private = ? AND $ch_grp_status != ? ".
								 	  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "0", PDO::PARAM_INT);
		$reponse -> bindValue(2, "D", PDO::PARAM_STR);
		$reponse -> bindValue(3, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(4, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_inactif($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups, $tb_groups_articles_map, $tb_article;
	global $ch_grp_id, $ch_grp_name, $ch_grp_description, $ch_grp_created_by, $ch_grp_creation_date, $ch_grp_private, $ch_grp_status;
	global $ch_grp_am_article_id, $ch_grp_am_group_id;
	global $ch_art_id, $ch_art_pubdate;	
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT * ".
									  "FROM( ".
									 	 "SELECT * ".
										 "FROM( ".
											"SELECT $ch_grp_am_group_id, $ch_grp_name, $tb_groups.$ch_grp_description, $ch_grp_am_article_id, $ch_art_pubdate, $ch_grp_created_by, $tb_groups.$ch_grp_creation_date, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $tb_groups.$ch_grp_status ".
											"FROM $tb_groups_articles_map, $tb_article, $tb_groups ".
											"WHERE $tb_article.$ch_art_id = $tb_groups_articles_map.$ch_grp_am_article_id ".
											"AND $tb_groups.$ch_grp_id = $tb_groups_articles_map.$ch_grp_am_group_id ".
											"ORDER BY $ch_grp_am_group_id, $ch_art_pubdate DESC ".											
										 ") TableFull ".
										 "GROUP BY $ch_grp_am_group_id ".
									  ") TableMiFull ".
									  "WHERE $ch_art_pubdate <= DATE_SUB(CURDATE(),INTERVAL 365 DAY) ".
									  "AND $ch_grp_status != ? ".
									 "ORDER BY $champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_delete($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status, $ch_grp_allowUnsubscribe;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $tb_groups.$ch_grp_id, $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status ".
								      "FROM $tb_groups ".								      
		 							  "WHERE $ch_grp_status = ? ".
								 	  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_groups_sansgestion($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_groups, $tb_users;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status, $ch_grp_allowUnsubscribe;
	global $ch_users_id;
	
	$groups = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_description, $ch_grp_status ".
									  "FROM $tb_groups WHERE $ch_grp_created_by NOT IN (SELECT $ch_users_id FROM $tb_users) AND $ch_grp_status != ? ".
								 	  "ORDER BY $tb_groups.$champ $order LIMIT ?,?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> bindValue(2, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(3, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $groups[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $groups;
}
function recuperer_infos_group($id)
{
	global $bdd_posh, $tb_groups, $tb_users;
	global $ch_grp_id, $ch_grp_name, $ch_grp_created_by, $ch_grp_private, $ch_grp_creation_date, $ch_grp_description, $ch_grp_status, $ch_grp_allowUnsubscribe;
	global $ch_users_id, $ch_users_username;
	
	$infos = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status, $ch_users_username ".
									  "FROM $tb_groups,$tb_users ".
									  "WHERE $tb_groups.$ch_grp_created_by = $tb_users.$ch_users_id ".
									  "AND $tb_groups.$ch_grp_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{	
			 $infos[] = $donnees;
		}	
		//Si l'user a été supprimé de la base, la requête au dessus ne fonctionnera pas, on va donc la simplifier
		//Un groupe n'est pas censé être supprimé, il est désactivé, donc la requête qui suit fonctionnera toujours.		
		if(empty($infos)){
			$reponse = $bdd_posh->prepare("SELECT $ch_grp_name, $ch_grp_created_by, DATE_FORMAT($tb_groups.$ch_grp_creation_date, \"%d/%m/%Y\") AS creation_date_formater, $ch_grp_private, $ch_grp_allowUnsubscribe, $tb_groups.$ch_grp_description, $ch_grp_status ".
										  "FROM $tb_groups ".										 
										  "WHERE $tb_groups.$ch_grp_id = ?");
			$reponse -> execute(array($id));
			while ($donnees = $reponse->fetch())
			{	
				 $infos[] = $donnees;
			}
		}
		
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $infos;
}
function recuperer_membres_group($id)
{
	global $bdd_posh, $tb_groups_users_map, $tb_users;
	global $ch_grp_um_user_id, $ch_grp_um_status, $ch_grp_um_group_id;
	global $ch_users_id, $ch_users_username, $ch_users_lastconnect_date;
	
	$membres = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_um_user_id, $ch_grp_um_status, $ch_users_username, DATE_FORMAT($ch_users_lastconnect_date, \"%d/%m/%Y\ à %Hh%i\") AS lastconnect_date_formater ".
								 	  "FROM $tb_groups_users_map,$tb_users ".
								 	  "WHERE $tb_users.$ch_users_id = $tb_groups_users_map.$ch_grp_um_user_id ".
								 	  "AND $ch_grp_um_group_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{	
			 $membres[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $membres;
}
function recuperer_membres_group_sansadmin($id,$admin)
{
	global $bdd_posh, $tb_groups_users_map, $tb_users;
	global $ch_grp_um_user_id, $ch_grp_um_status, $ch_grp_um_group_id;
	global $ch_users_id, $ch_users_username, $ch_users_lastconnect_date;
	
	$membres = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_um_user_id, $ch_grp_um_status, $ch_users_username, DATE_FORMAT($ch_users_lastconnect_date, \"%d/%m/%Y\ à %Hh%i\") AS lastconnect_date_formater ".
								 	  "FROM $tb_groups_users_map,$tb_users ".
								 	  "WHERE $tb_users.$ch_users_id = $tb_groups_users_map.$ch_grp_um_user_id ".
								 	  "AND $ch_grp_um_group_id = ? ".
								 	  "AND $ch_users_username != ? ");
		$reponse -> execute(array($id,$admin));
		while ($donnees = $reponse->fetch())
		{	
			 $membres[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $membres;
}
function recuperer_articles_group($id)
{
	global $bdd_posh, $tb_groups_articles_map, $tb_article, $tb_users;
	global $ch_grp_am_article_id, $ch_grp_am_group_id, $ch_grp_am_status, $ch_grp_am_owner_id, $ch_grp_am_user_id;
	global $ch_art_id, $ch_art_title, $ch_art_pubdate;
	global $ch_users_id, $ch_users_username;
	
	$articles = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_am_article_id, $ch_grp_am_group_id, $tb_groups_articles_map.$ch_grp_am_status, $ch_grp_am_owner_id, $ch_grp_am_user_id, $ch_art_title, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y\ à %Hh%i\") AS pubdate_formater, $ch_users_username ".
									  "FROM $tb_groups_articles_map, $tb_article, $tb_users ".
									  "WHERE $tb_article.$ch_art_id = $tb_groups_articles_map.$ch_grp_am_article_id ".
									  "AND $tb_groups_articles_map.$ch_grp_am_owner_id = $tb_users.$ch_users_id ".
									  "AND $ch_grp_am_group_id = ? ORDER BY $ch_art_pubdate DESC");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{	
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_group_recherche($texte)
{
	global $bdd_posh, $tb_groups;
	global $ch_grp_id, $ch_grp_name, $ch_grp_description;
	
	$group = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_grp_id, $ch_grp_name, $ch_grp_description ".
									  "FROM $tb_groups ".
									  "WHERE $ch_grp_name LIKE '%' ? '%'".
									  "OR $ch_grp_description LIKE '%' ? '%'");
		$reponse -> execute(array($texte,$texte));		
		while($donnees = $reponse->fetch())
		{
			$group[] = $donnees;
		}
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	} 
	return $group;
}
