<?php
function recuperer_admins()
{
	global $bdd_posh, $tb_users;
	global $ch_users_id, $ch_users_username, $ch_users_lastconnect_date, $ch_users_typ, $ch_users_keywords;
	
	$admins = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_users_username, DATE_FORMAT($ch_users_lastconnect_date, '%d/%m/%Y à %Hh%i') AS lastco_formater, $ch_users_keywords ".
									  "FROM $tb_users ".
									  "WHERE $ch_users_typ = ?");
		$reponse -> execute(array("A"));
		while ($donnees = $reponse->fetch())
		{	
			 $admins[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $admins;
}
function recuperer_users()
{
	global $bdd_posh, $tb_users;
	global $ch_users_id, $ch_users_username, $ch_users_lastconnect_date, $ch_users_typ, $ch_users_keywords;
	
	$users = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_users_username, DATE_FORMAT($ch_users_lastconnect_date, '%d/%m/%Y à %Hh%i') AS lastco_formater, $ch_users_keywords ".
									  "FROM $tb_users");
									  
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{	
			 $users[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $users;
}
function recuperer_users_total($champ,$order,$depart,$delta)
{
	global $bdd_posh, $tb_users;
	global $ch_users_id, $ch_users_username, $ch_users_lastconnect_date;
	
	$users = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_users_username, DATE_FORMAT($ch_users_lastconnect_date, '%d/%m/%Y à %Hh%i') AS lastco_formater ".
									  "FROM $tb_users ".
									  "ORDER BY $champ $order LIMIT ?,?");		
		$reponse -> bindValue(1, $depart, PDO::PARAM_INT);
		$reponse -> bindValue(2, $delta, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{				
			$users[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}	
	return $users;
}
function recuperer_infos_user($id)
{
	global $bdd_posh, $tb_users;
	global $ch_users_id;
	
	$infos = array();
	try{		
		$reponse = $bdd_posh->prepare("SELECT * FROM $tb_users WHERE $ch_users_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{	
			 $infos[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $infos;	
}
function compter_users()
{
	global $bdd_posh, $tb_users;
	global $ch_users_id;
		
	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_users_id) AS cpt_user FROM $tb_users");
		$reponse -> execute(array());
		$donnees = $reponse->fetch();
		$cpt_users = $donnees['cpt_user'];
		$reponse->closeCursor();		
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_users;
}
function is_admin($user_login)
{
	global $bdd_posh, $tb_users;
	global $ch_users_username, $ch_users_typ; 
	
	try{
		$reponse = $bdd_posh->prepare("SELECT count(*) AS cpt_user ".
									  "FROM $tb_users ".
									  "WHERE $ch_users_username = ? ".
								 	  "AND $ch_users_typ = ?");
		$reponse -> execute(array($user_login,"A"));
		$donnees = $reponse->fetch();
		$reponse->closeCursor();
	}catch(PDOException $e){
		echo 'Exception : '.$e->getMessage();
	}
	return $donnees['cpt_user'];
}
function ajouter_admin($user_login)
{	
	global $bdd_posh, $tb_users;
	global $ch_users_username, $ch_users_typ; 
	
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_users SET $ch_users_typ = ? WHERE $ch_users_username = ? AND $ch_users_username!= ?");
		$reponse -> execute(array("A",$user_login,"admin"));					
		$reponse -> closeCursor();
		return true;
	}catch (Exception $e)
	{			
		die('Erreur : ' . $e->getMessage());
		return false;
	}
}
function supprimer_admin($user_login)
{	
	global $bdd_posh, $tb_users;
	global $ch_users_username, $ch_users_typ; 
	
	try{
		$reponse = $bdd_posh->prepare("UPDATE $tb_users SET $ch_users_typ = ? WHERE $ch_users_username = ? AND $ch_users_username != ?");
		$reponse -> execute(array("I",$user_login,"admin"));	
		$reponse -> closeCursor();
		return true;
	}catch (Exception $e)
	{		
		die('Erreur : ' . $e->getMessage());
		return false;		
	}	
}
function is_exist($user_login)
{		
	global $bdd_posh, $tb_users;
	global $ch_users_username;
	
	try{
		$reponse = $bdd_posh->prepare("SELECT count(*) AS cpt_user ".
								 	  "FROM $tb_users ".
								 	  "WHERE $ch_users_username = ? ");
		$reponse -> execute(array($user_login));
		$donnees = $reponse->fetch();
		$reponse->closeCursor();
	}catch(PDOException $e){
		echo 'Exception : '.$e->getMessage();
	}
	return $donnees['cpt_user'];
}
function recuperer_users_autocomplete($q)
{

	global $bdd_posh, $tb_users;
	global $ch_users_username;
	
	$users = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_users_username FROM $tb_users WHERE $ch_users_username LIKE '%' ? '%' LIMIT 0, 10");
		$reponse -> execute(array($q));
		while ($donnees = $reponse->fetch())
		{	
			 $users[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $users;
}
function recuperer_user_recherche($texte)
{
	global $bdd_posh, $tb_users;
	global $ch_users_id, $ch_users_long_name;
	
	$users = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_users_id, $ch_users_long_name ".
									  "FROM $tb_users ".									 
									  "WHERE $ch_users_long_name LIKE '%' ? '%'");
		$reponse -> execute(array($texte));		
		while($donnees = $reponse->fetch())
		{
			$users[] = $donnees;
		}
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	} 
	return $users;
}
