<?php 
if(isset($_SESSION['user_login'])&&(!empty($_SESSION['user_login']))){	
	$user_login = Secure::bdd($_SESSION['user_login']);

	if(is_admin($user_login)){	
?>
<!doctype html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html lang="fr">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<title>Administration <?php echo $project_article_p.' '.$project_name;?></title>
	<script>var url_img = "<?php echo $url_img; ?>";</script>
	<script type="text/javascript" src="lib/functions.js"></script>
	<script type="text/javascript" src="lib/jquery/jquery.js"></script>
	<link rel="stylesheet" type="text/css" href="<?php echo $url_css;?>/main.css"/>
	<script>	
	$(document).ready(function(){
		hide_logs();
	});
	function show_logs(type){
		hide_logs();
		$('#content_accueil_logs_'+type+'').slideUp(0).fadeIn(400);
	}
	function hide_logs(){
		$('#content_accueil_logs_A').hide();
		$('#content_accueil_logs_O').hide();
	}
	</script>
</head>
<body>
	<div id="container">
	<table class="menu_title">
	<tr>
		<td colspan="2" class="td_main">
			<?php include dirname(__FILE__).'/menu.php';?>
		</td>
	</tr>	
	</table>
	<div id="content">			
		<div id="content_activite">
			<h3>Dernières activités <?php echo $project_article_p.' '.$project_name; ?></h3>
			<div id="content_activite_groups">
				<h4><img src="<?php echo $url_img;?>/group.png"/><a href="index.php?page=groupes" class="link_back"> Groupes</a></h4>
				<ul>
					<?php
					foreach($groupes_recents as $key => $groupe){		
						if($groupe['name']!=''){
							echo '<li><div class="force_overflow">'.Secure::html($groupe['creation_date_formater']).' : '.Secure::html($groupe['name']).'</div></li>';
						}else{
							echo '<li>'.Secure::html($groupe['creation_date_formater']).' : Vide</li>';
						}
					}									
					?>
				</ul>
			</div>
			<div id="content_activite_articles">
				<h4><img src="<?php echo $url_img;?>/article.png"/><a href="index.php?page=articles" class="link_back"> Articles</a></h4>
				<ul>
					<?php							
					foreach($articles_recents as $key => $article){
						if($article['title']!=''){
							echo '<li><div class="force_overflow">'.Secure::html($article['pubdate_formater']).' : '.Secure::html($article['title']).'</div></li>';
						}else{
							echo '<li>'.Secure::html($article['pubdate_formater']).' : Vide</li>';
						}
					}	
					?>
				</ul>
			</div>
			<div id="content_activite_comments">
				<h4><img src="<?php echo $url_img;?>/comment.png"/><a href="index.php?page=comments" class="link_back"> Commentaires</a></h4>
				<ul>
					<?php						
					foreach($comments_recents as $key => $comment){
						if($comment['message']!=''){
							echo '<li><div class="force_overflow">'.Secure::html($comment['pubdate_formater']).' : '.Secure::html($comment['message']).'</div></li>';
						}else{
							echo '<li>'.Secure::html($comment['pubdate_formater']).' : Vide</li>';
						}		
					}
					?>
				</ul>
			</div>
		</div>
		<div id="content_accueil">
			<h3>Accueil</h3>
			<div id="content_accueil_infos">
				<h4>Informations</h4>
				<ul>
					<li><b>Nom du projet</b> : <?php echo $project_name; ?></li>
					<li><b>Adresse du projet</b> : <?php echo $adresse; ?></li>	
					<li><b>Thème utilisé</b> : <?php echo $theme; ?></li>					
					<li><b>Connexion CAS activée</b> : <?php echo ($use_CAS ? "<span style='color:green;'>Oui</span>" : "<span style='color:red;'>Non</span>"); ?></li>				
					<li><b>Connexion LDAP fonctionelle</b > : <?php echo (test_connection_ldap() ? "<span style='color:green;'>Oui</span>" : "<span style='color:red;'>Non</span>"); ?></li>
				</ul>
				<h4>Statistiques</h4>
				<ul>
				<?php
					echo '<li><b>'.Secure::html($compteur_users).'</b> utilisateurs</li>';
					echo '<li><b>'.Secure::html($compteur_groupe).'</b> groupes</li>';
					echo '<li><b>'.Secure::html($compteur_articles).'</b> articles</li>';
					echo '<li><b>'.Secure::html($compteur_comments).'</b> commentaires</li>';
				?>
				</ul>
				<span class="logs_main">
					<span class="logs" onclick="show_logs('A');">Logs actions</span> | <span class="logs" onclick="show_logs('O');">Logs erreurs</span>		
				</span>
			</div>
			<div id="content_accueil_logs_A">				
				<h4>Logs de l'application - Actions</h4>
				<ul class="liste_logs">
				<?php
				foreach($logs_recents_A as $key => $log){
						if($log['log']!=''){
							echo '<li><div class="force_overflow">'.Secure::html($log['logdate_formater']).' : '.Secure::html($log['log']).'</div></li>';
						}else{
							echo '<li>'.Secure::html($log['logdate_formater']).' : Vide</li>';
						}
					}
				?>
				</ul>
			</div>
			<div id="content_accueil_logs_O">				
				<h4>Logs de l'application - Erreurs</h4>
				<ul class="liste_logs">
				<?php
				foreach($logs_recents_O as $key => $log){
						if($log['log']!=''){
							echo '<li><div class="force_overflow">'.Secure::html($log['logdate_formater']).' : '.Secure::html($log['log']).'</div></li>';
						}else{
							echo '<li>'.Secure::html($log['logdate_formater']).' : Vide</li>';
						}
					}
				?>
				</ul>
			</div>
		</div>
		<div id="content_info">		
		</div>
	</div>
</div>
</body>
</html>
<?php 
	}else{
		echo "<p class=\"erreur\">Erreur - Vous ne pouvez accéder à cette ressource.</p>";
	}
}else{
	echo "<p class=\"erreur\">Erreur - Mauvaise gestion des utilisateurs. Merci de contacter l'administrateur.</p>";
}
?>
