<?php
/**********************************************************************************************************/
/*********************************************** Fonctions LDAP *******************************************/
/**********************************************************************************************************/
function test_connection_ldap(){
	require dirname(__FILE__).'/../config/ldap.inc.php';
	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport);
		if(@ldap_bind($ldapconn)){
			return true;
		}else{
			return false;
		}			
		ldap_close($ldapconn);
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
}
function recup_infos_ldap($user_login){
	require dirname(__FILE__).'/../config/ldap.inc.php';
	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport) or die("Impossible de se connecter au serveur LDAP {$ldaphost}");
		$infos_user_ldap = array();
		if($ldapconn){
			$ldapbind = ldap_bind($ldapconn);
	 		if($ldapbind){
	    		$filtre = $ldap_uid."=".$user_login;
		        $read = ldap_search($ldapconn,$ldapdn,$filtre);
		        $info = ldap_get_entries($ldapconn,$read);
				if(isset($info[0][$ldap_cn][0])){		      
		        	 $infos_user_ldap[0] = $info[0][$ldap_cn][0];
		        }	       
		        if(isset($info[0][$ldap_mail][0])){		      
		        	$infos_user_ldap[1] = $info[0][$ldap_mail][0];
		        }
	    	}else{
	       		echo 'Connexion LDAP anonmye échouée';
	    	}
		}else{
			echo 'Erreur de connection au serveur LDAP';
		}
		ldap_close($ldapconn);
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
	return $infos_user_ldap;
}
function is_user_exist_uid($uid){
	require dirname(__FILE__).'/../config/ldap.inc.php';
	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport) or die("Impossible de se connecter au serveur LDAP {$ldaphost}");	
		if($ldapconn){
			$ldapbind = ldap_bind($ldapconn);	
	 		if($ldapbind){
	    		$filtre = $ldap_uid."=".$uid;
		        $read = ldap_search($ldapconn,$ldapdn,$filtre);
		        $info = ldap_get_entries($ldapconn,$read);
				if(empty($info[0][$ldap_uid][0])){
					return false;
				}else{			
					return true;
				}
	    	}else{
	       		echo 'Connexion LDAP anonmye échouée';
	    	}	     
		}else{
			echo 'Erreur de connection au serveur LDAP';
		}
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
	ldap_close($ldapconn);
}
//Fonction qui retourne une couleur en fonction du pourcentage, utilisée dans la création des progress bar
//Générateur de degradé http://www.jokconcept.net/generateur-nuancier-degrade-couleurs.php
function couleur_pourc($pourc){
	switch ($pourc){
		case ($pourc >= 90) :
			$couleur = '#4483BC';
			break;
		case (($pourc >= 80) && ($pourc < 90)) :
			$couleur = '#528CC1';
			break;
		case (($pourc >= 70) && ($pourc < 80)) :
			$couleur = '#6196C5';
			break;
		case (($pourc >= 60) && ($pourc < 70)) :
			$couleur = '#6F9FCA';
			break;
		case (($pourc >= 50) && ($pourc < 60)) :
			$couleur = '#7EA8CF';
			break;
		case (($pourc >= 40) && ($pourc < 50)) :
			$couleur = '#8CB1D4';
			break;
		case (($pourc >= 30) && ($pourc < 40)) :
			$couleur = '#9BBAD9';
			break;
		case (($pourc >= 20) && ($pourc < 30)) :
			$couleur = '#A9C3DE';
			break;
		case (($pourc >= 10) && ($pourc < 20)) :
			$couleur = '#B8CDE2';
			break;
		case ($pourc < 10) :
			$couleur = '#C6D6E7';
			break;		
		default :
			$couleur = '#C6D6E7';
			break;
	}
	return $couleur;
}
//Fonction qui calcul un pourcentage en fonction d'un compteur et d'un compteur total
function calcul_pourc($arr_compteurs,$compteur_total){	
	$arr_res = array();	
	foreach($arr_compteurs as $compteur){
		if($compteur_total!=0){	
			$arr_res[] = intval($compteur*100/$compteur_total);
		}else{
			$arr_res[] = 0;
		}
	}	
	return $arr_res;
}
//Fonction qui renvoi le type d'article
function type_article($type_in){	
	switch($type_in){
			case "1":
				$type = "Article";
				break;
			case "3":
				$type = "Widget partagé";
				break;
			case "4":
				$type = "Onglet partagé";
				break;
			case "6":
				$type = "Status";
				break;
			case "9":
				$type = "Évenement";
				break;
			default :
				$type = "Autre";
				break;
		}	
	return $type;
}
//Fonction de redirection
function redir($adresse)
{
	echo "<script type=\"text/javascript\">  window.location.replace(\"".$adresse."\");  </script>";
	exit();
}
//Fonction qui retourne les boutons de pages précedentes et suivantes
function afficherPageUtile($depart,$nbrResultats,$page_avant,$page_apres,$delta){
	if($depart==0){
		$page_utile = $page_apres;
	}elseif($depart >= ($nbrResultats - $delta)){
		$page_utile = $page_avant;
	}else{
		$page_utile = $page_avant.$page_apres;
	}
	return $page_utile;
}
//Fonction qui retourne à partir de quel enregistrement l'affichage doit se faire
function afficherDepart($depart,$limit,$nbrResultats,$delta){	
	switch($limit){
		case 0:
			$depart = 0;
			break;
		case -1:
			if($depart!=0){
				$depart = $depart - $delta;			
			}
			break;
		case 1:	
			if($depart < ($nbrResultats - $delta)){
				$depart = $depart + $delta;
			}
			break;
		default:
			$depart = 0;
			break;
	}
	return $depart;
}